"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Sqlite3Plus = void 0;
const sq3 = __importStar(require("sqlite3"));
const removeSqlite3CommentLines = (sql) => sql.replace(/^\s*--.*$/gmu, "");
class Sqlite3Plus {
    constructor(db) {
        this.db = db;
        this.close = () => new Promise((resolve, reject) => {
            this.db.close((err) => {
                if (err) {
                    reject(err);
                }
                else {
                    resolve();
                }
            });
        });
        this.query = (statement, params) => new Promise((resolve, reject) => {
            this.db.all(statement, params, (err, rows) => {
                if (err) {
                    reject(err);
                }
                else {
                    resolve(rows);
                }
            });
        });
        this.run = (statement, params) => new Promise((resolve, reject) => {
            this.db.run(statement, params, function (err) {
                if (err) {
                    reject(err);
                }
                else {
                    resolve({
                        lastId: this.lastID,
                        changes: this.changes,
                    });
                }
            });
        });
        this.exec = (sql) => new Promise((resolve, reject) => {
            // node-sqlite3 does not support comments in `exec`.
            this.db.exec(removeSqlite3CommentLines(sql), (err) => {
                if (err) {
                    reject(err);
                }
                else {
                    resolve();
                }
            });
        });
    }
}
exports.Sqlite3Plus = Sqlite3Plus;
Sqlite3Plus.open = (filename) => new Promise((resolve, reject) => {
    // WARNING: If `mode` argument is provided, it must not be undefined,
    // as otherwise the library will think it's omitted and interpret the `mode`
    // arg as the callback, meaning the actual callback never gets called.
    const db = new sq3.Database(filename, (err) => {
        if (err) {
            reject(err);
        }
        else {
            resolve(new Sqlite3Plus(db));
        }
    });
});
